Subject: re: MMDF format mailboxes

From: Andy Powell <[email-masked]>
Date: Wed, 30 Mar 1994 16:37:23 +0100 (BST)

On Tue, 16 Nov 1993, Mark Crispin wrote:

> In order to enable MMDF support, you need to add a mail_link(&mmdfdriver) call
> in pine.c.  You will probably have to do some other hacking as well; at the
> present time the bezerkdriver and the mmdfdriver do not tolerate each other
> very well.  Also, it isn't clear how well the mmdfdriver actually works; it is
> contributed code.
> 
> I have recently spent a great deal of effort with c-client (it's now available
> with IMAP toolkit 3.2, mail/imap-3.2.tar.Z on ftp.cac.washington.edu) to get
> mmdfdriver and bezerkdriver to co-exist and a number of other highly desirable
> internal improvements.  This doesn't answer whether or not the mmdfdriver
> actually works (I don't know, not having an MMDF system to play with), but it
> should make experimentation with MMDF format much easier.

I've finally got round to playing with Pine in an MMDF environment 
again.  Some good news some bad news.

First the good news...  I've hacked pine/send.c so that it calls the MMDF 
submit library routines directly (rather than having to interface via the 
MMDF sendmail replacement or over an SMTP connection).  This allows for 
immediate reporting of address errors.  The code is currently being 
tested here but I hope to get something to you soon, hopefully with the 
aim of getting it incorporated into a future release?  (The code changes 
are fairly small and #ifdef in cleanly).

Now the bad news...  I can't get the mmdf driver to work at all on our 
MMDF mailboxes.  Is anyone using these drivers with MMDF update 43 (or 
any other version for that matter)?  The VALID macro (from mmdf.h) is 
looking for a mailbox with messages separated by 4 CTRL-A's, then a 
newline, then a line like "From blah blah blah".  Our mailboxes here 
don't look like that :-(.  They just have the 4 CTRL-A's followed by a 
newline - then you go straight into the message.

I've tried making the VALID macro much simpler (i.e it just checks for
"\001\001\001\001\n") but unfortunately routines like mmdf_parse() appear
to want to do things with that non-existant From line :-(. 

I think I need some explanation of how the "From " line is being used 
and whether mmdf driver routines can be written that don't rely on 
having such a line at the start of each message.  Do any of the other 
drivers not rely on such a line?

BTW, I've been working with the c-client libraries from imap-3.3.  You 
should note that both the mmdf and bezerk drivers include (different) 
definitions of the VALID macro.  This may account for the difficulties in 
trying to use both drivers together?

Any help would be greatly appreciated.

Thanks, Andy.
--
BUCS, University of Bath, Bath, BA2 7AY, UK          Voice: +44 225 826485
[email-masked]                                    Fax: +44 225 826176